#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const int coffset = 97;

int countbits(int N){
	int count = 0;
	while(N > 0){
		count += N & 1;
		N >>= 1;
	}
	return count;
}

int part1(char* in);
int part2(char* in);

int main (int argc, char**argv){
	int  length = 0;
    FILE *f = fopen(argv[1], "r");
    char *input;
    if (!f) return -1; 
    fseek(f, 0, SEEK_END);
    length = ftell(f);
	rewind(f);
    input = (char*)malloc(sizeof(char) * (length+1));
    fread(input, sizeof(char), length, f);
    fclose(f);
    ((char*)input)[length] = '\0';

	//part1(input);	
	part2(input);
	return 0;
}

int part1(char* in){
	char * line = 0;
	int sum = 0;
	int groupbits = 0;
	while((line = strsep(&in, "\n"))!= NULL){
		if(strlen(line) == 0){
			sum += countbits(groupbits);
			groupbits = 0;
			continue;
		}
		for(int i=0;i<strlen(line);i++){
			groupbits |= (1 << ((int)line[i] - coffset));
		}
	}
	printf("Sum of sums: %d\n", sum);
}

int part2(char* in){
	char * line = 0;
	int sum = 0;
	int groupbits = ~0;
	int passengerbits = 0;
	while((line = strsep(&in, "\n"))!= NULL){
		if(strlen(line) == 0){
			sum += countbits(groupbits);
			groupbits = ~0;
			continue;
		}
		for(int i=0;i<strlen(line);i++){
			passengerbits |= (1 << ((int)line[i] - coffset));
		}
		groupbits &= passengerbits;
		passengerbits = 0;
	}
	printf("Sum of sums: %d\n", sum);
}
